#include <fstream>
#include <iostream>
#include <cmath>
#include <cstdio>
#include <set>
#include <algorithm>

int main()
{
    int k = 0;
    ifstream file("atlantis.in");
    int lines;
    file >> lines;
    while (lines > 0)
    {
        cout << "Test case #" << ++k << endl;
        set<double> coll;
        
        double x1[100], x2[100], y1[100], y2[100];
        double ymin=100001, ymax=0, xlast=0;
        double area = 0;
        
        for (int i = 0; i < lines; ++i)
        {
            file >> x1[i] >> y1[i] >> x2[i] >> y2[i];
            if (x1[i] > x2[i])
                swap(x1[i], x2[i]);
            if (y1[i] > y2[i])
                swap(y1[i], y2[i]);
            
            coll.insert(x1[i]);
            coll.insert(x2[i]);
        }
        set<double>::iterator pos;
        for(pos = coll.begin(); pos != coll.end(); ++pos)
        {
            double x = *pos;
            
            area += (ymax - (ymin==100001?0:ymin)) * (x - xlast);
//             cout << x << ' ' << ymin << ' ' << ymax << ' ' << xlast 
//                  << ' ' << area << endl;
            xlast = x;
            ymax = 0;
            ymin = 100001;
            
            for(int i = 0; i < lines; ++i)
            {
                if ((x1[i] <= x) && (x2[i] > x))
                {
                    if (ymin > y1[i]) ymin = y1[i];
                    if (ymax < y2[i]) ymax = y2[i];
                }
            }
        }
        
        printf("Total explored area: %.2f\n", area);
        cout << endl;
        file >> lines;
    }
}
