#include <fstream>
#include <iostream>
#include <map>
#include <string>
#include <list>

int main()
{
    ifstream file("erdos.in");
    int cases, names;
    
    while (true)
    {
        file >> cases >> names;
        if ((cases == 0) && (names == 0)) break;
        
        typedef map<string, int> MStringInt;
        typedef map<string, string> MStringString;
        
        MStringInt erdos;
        MStringString erdo2;
        
        const int infty = -1;
        
        string s;
        getline(file, s);
        for (int i = 1; i <= cases; ++i)
        {
            getline(file, s);
            string name;
            s = s.substr(0, s.find(':'));
            cout << s << endl;
            char x;
            
            cin >> x;
            
            string::size_type idx1, idx2;
            string oldname = "";
            
            do 
            {
                idx1 = s.find(',');
                idx2 = s.find(',', idx1+1);
                string name2 = s.substr(0, idx2);
                cout << name2 << endl;
                
                if ((oldname != ""))
                {
                    erdo2[oldname] = name2;
                    erdo2[name2] = name2;
                    erdo2[name2] = oldname;
                    
                    erdos[name2] = infty;
                }
                s = s.substr(idx2+1);
                oldname = name2;
            } while (idx2 != string::npos);
            
        }
        
// Calculate now
        erdos["Erdos, P."] = 0;
        
        bool changed = true;
        
        while (changed)
        {
            MStringString::iterator pos2 = erdo2.begin();
            changed = false;
            cout << "Begin" << endl;
            
            while (pos2 != erdo2.end())
            {
                if (erdos[pos2->first] != infty)
                {
                    changed = true;
            
                    cout << "Changed" << endl;
                    
                    if (erdos[pos2->second] > (erdos[pos2->first] + 1))
                        erdos[pos2->second] = erdos[pos2->first] + 1;
                    
                    erdo2.erase(pos2, ++pos2);
                    break;
                }
                ++pos2;
            }
        }
        break;
        }
}

                    
